%define         debug_package %{nil}

Name:	 	mono-sharpcvslib
Version:	0.35
Release:	14%{?dist}
Summary:	Client cvs library written in C#
URL:		http://sharpcvslib.sourceforge.net/
# Exception: Permission is given to use this library in commercial closed-source applications
# See: README.txt
License:	GPLv2+ with exceptions
Group:		System Environment/Libraries
# Upstream Source is here: http://downloads.sourceforge.net/sharpcvslib/SharpCvsLib-0.35.3721.507-src.zip
# Unfortunately, they use windows separators. This is the same thing, just rezipped with unix separators.
Source0:	SharpCvsLib-0.35.3721.507-src-unix.zip
Source1:	sharpcvslib.pc
Patch0:		sharpcvslib-cleanups.patch
Patch1:		sharpcvslib-key.patch
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires:	mono-devel >= 2.2, log4net-devel, nant, mono-nunit22-devel
BuildRequires:	unzip
ExcludeArch:	ppc64 ppc sparc64

%description
Gives C# projects the ability to communicate with a CVS server.

%package devel
Summary:	Client cvs library written in C#
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	pkgconfig

%description devel
Gives C# projects the ability to communicate with a CVS server.

%prep
%setup -q -c -n sharpcvslib-%{version}
# We need this to compile.
%patch0 -p1 -b .cleanups
%patch1 -p1 -b .key
# Get rid of the binary dlls
rm -rf src/lib/*
rm -rf src/tools/nant/*
# There is probably a better way to do this, but this works.
# All these guys are built from source.
mkdir -p src/lib/ext/
cp %{_libdir}/mono/log4net/log4net.dll src/lib/ext/
cp %{_libdir}/mono/2.0/ICSharpCode.SharpZipLib.dll src/lib/
cp %{_libdir}/mono/nunit22/nunit.framework.dll src/lib/ext/
%{__sed} -i 's/\r//' src/doc/README.txt
%{__sed} -i 's/\r//' src/doc/COPYING.txt

%build
# Use the mono system key instead of generating our own here.
cp -a /etc/pki/mono/mono.snk SharpCvsLib.snk
cd src/build
nant -buildfile:SharpCvsLib.build build.all
# This command works mostly, but fails at the end trying to talk to the Windows registry.
nant -buildfile:SharpCvsLib.build netdoc ||:



%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__mkdir_p} $RPM_BUILD_ROOT/%{_libdir}/pkgconfig
cp %{S:1} $RPM_BUILD_ROOT/%{_libdir}/pkgconfig
%{__mkdir_p} $RPM_BUILD_ROOT/%{_libdir}/mono/gac/
gacutil -i src/bin/cvs.exe -f -package sharpcvslib -root ${RPM_BUILD_ROOT}/%{_libdir}/
gacutil -i src/bin/ICSharpCode.SharpCvsLib.dll -f -package sharpcvslib -root ${RPM_BUILD_ROOT}/%{_libdir}
gacutil -i src/bin/ICSharpCode.SharpCvsLib.Tests.dll -f -package sharpcvslib -root ${RPM_BUILD_ROOT}/%{_libdir}
gacutil -i src/bin/ICSharpCode.SharpCvsLib.Tests-sample.dll -f -package sharpcvslib -root ${RPM_BUILD_ROOT}/%{_libdir}

# Cleanup docs
%{__sed} -i 's/\r//' src/doc/api/msdn/SharpCvsLib.log
%{__sed} -i 's/\r//' src/doc/api/msdn/SharpCvsLib.hhp
%{__sed} -i 's/\r//' src/doc/api/msdn/tree.css
%{__sed} -i 's/\r//' src/doc/api/msdn/MSDN.css
%{__sed} -i 's/\r//' src/doc/api/msdn/tree.js
iconv -f iso-8859-1 -t utf-8 -o src/doc/api/msdn/tree.js{.utf8,}
mv src/doc/api/msdn/tree.js{.utf8,}

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc src/doc/README.txt src/doc/COPYING.txt src/doc/*.html
%doc src/doc/images/
%{_libdir}/mono/gac/cvs/
%{_libdir}/mono/gac/ICSharpCode.SharpCvsLib*/
%{_libdir}/mono/sharpcvslib/

%files devel
%defattr(-,root,root,-)
%doc src/doc/api/
%{_libdir}/pkgconfig/sharpcvslib.pc

%changelog
* Thu Dec  3 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 0.35-14
- bump it once more for nant

* Tue Dec  1 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 0.35-13
- use the system mono.snk key instead of regenerating on every build

* Mon Oct 26 2009 Dennis Gilmore <dennis@ausil.us> - 0.35-12
- ExcludeArch sparc64

* Fri Jul 31 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 0.35-11
- rebuild again

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.35-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Mar  2 2009 Tom "spot" Callaway <tcallawa@redhat.com> 0.35-9
- rebuild again

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.35-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Dec 23 2008 Tom "spot" Callaway <tcallawa@redhat.com> 0.35-7
- copy the right nunit22 lib

* Thu Dec 18 2008 Paul F. Johnson <paul@all-the-johnsons.co.uk> 0.35-6
- Added BR mono-nunit22-devel instead of mono-nunit

* Thu Dec 18 2008 Paul F. Johnson <paul@all-the-johnsons.co.uk> 0.35-5
- Fix BR for mono-nunit-devel and mono-devel
- Remove empty debug package

* Mon Dec 15 2008 Paul F. Johnson <paul@all-the-johnsons.co.uk> 0.35-4
- rebuild

* Thu Jun  5 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.35-3
- rebuild for new mono bits

* Sat Apr 12 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.35-2
- be consistent with case for "C#"
- add ppc to ExcludeArch, due to nant
- use 1.0 nunit.framework.dll, so this will work on F-8

* Thu Apr 10 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.35-1
- initial package for Fedora
